recursion-visualizer
================

<!-- WARNING: THIS FILE WAS AUTOGENERATED! DO NOT EDIT! -->

Stop drawing recursion trees by hand.
[`RecursionVisualizer`](https://ez2rok.github.io/recursion-visualizer/recurse.html#recursionvisualizer)
creates beautiful, interactive visualizations with a single line of
code.

Visualize computing the n-th [fibonacci
number](https://en.wikipedia.org/wiki/Fibonacci_number) like this:

``` python
@RecursionVisualizer()
def fibonacci(n):
  if n <= 2: 
    return 1
  return fibonacci(n-1) + fibonacci(n-2)
```

``` python
fibonacci(5)
```

<div>                            <div id="ca44f2f7-46f7-4844-bc1a-8dff23340d6d" class="plotly-graph-div" style="height:525px; width:100%;"></div>            <script type="text/javascript">                require(["plotly"], function(Plotly) {                    window.PLOTLYENV=window.PLOTLYENV || {};                                    if (document.getElementById("ca44f2f7-46f7-4844-bc1a-8dff23340d6d")) {                    Plotly.newPlot(                        "ca44f2f7-46f7-4844-bc1a-8dff23340d6d",                        [{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[0,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],                        {"annotations":[{"showarrow":false,"text":"Made with <a href='https://github.com/ez2rok/recursion-visualizer'>Recursion Visualizer</a>","x":0.005,"xref":"paper","y":-0.002,"yref":"paper"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":158.0,"xref":"x","y":203.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":104.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":50.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":86.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":140.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":194.0,"xref":"x","y":203.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":212.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":248.0,"xref":"x","y":131.0,"yref":"y"}],"margin":{"b":0,"l":5,"r":5,"t":5},"sliders":[{"active":0,"currentvalue":{"font":{"size":20},"prefix":"Time:","visible":true,"xanchor":"right"},"len":0.9,"pad":{"b":5,"t":5},"steps":[{"args":[[0],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"0","method":"animate"},{"args":[[1],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"1","method":"animate"},{"args":[[2],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"2","method":"animate"},{"args":[[3],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"3","method":"animate"},{"args":[[4],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"4","method":"animate"},{"args":[[5],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"5","method":"animate"},{"args":[[6],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"6","method":"animate"},{"args":[[7],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"7","method":"animate"},{"args":[[8],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"8","method":"animate"},{"args":[[9],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"9","method":"animate"},{"args":[[10],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"10","method":"animate"},{"args":[[11],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"11","method":"animate"},{"args":[[12],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"12","method":"animate"},{"args":[[13],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"13","method":"animate"},{"args":[[14],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"14","method":"animate"},{"args":[[15],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"15","method":"animate"},{"args":[[16],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"16","method":"animate"},{"args":[[17],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"17","method":"animate"},{"args":[[18],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"18","method":"animate"}],"transition":{"duration":300,"easing":"cubic-in-out"},"x":0.1,"xanchor":"left","y":0,"yanchor":"top"}],"title":{"text":"Recursive Tree: fibonacci(5)","x":0.02,"xanchor":"left","y":0.95,"yanchor":"top"},"updatemenus":[{"buttons":[{"args":[null,{"frame":{"duration":500,"redraw":false},"fromcurrent":true,"transition":{"duration":300,"easing":"quadratic-in-out"}}],"label":"Play","method":"animate"},{"args":[[null],{"frame":{"duration":0,"redraw":false},"mode":"immediate","transition":{"duration":0}}],"label":"Pause","method":"animate"}],"direction":"up","pad":{"r":20,"t":15},"showactive":true,"type":"buttons","x":0.1,"xanchor":"right","y":0,"yanchor":"top"}],"xaxis":{"showgrid":false,"showline":false,"showticklabels":false,"zeroline":false},"yaxis":{"showgrid":false,"showline":false,"showticklabels":false,"zeroline":false},"template":{"data":{"histogram2dcontour":[{"type":"histogram2dcontour","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"choropleth":[{"type":"choropleth","colorbar":{"outlinewidth":0,"ticks":""}}],"histogram2d":[{"type":"histogram2d","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"heatmap":[{"type":"heatmap","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"heatmapgl":[{"type":"heatmapgl","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"contourcarpet":[{"type":"contourcarpet","colorbar":{"outlinewidth":0,"ticks":""}}],"contour":[{"type":"contour","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"surface":[{"type":"surface","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"mesh3d":[{"type":"mesh3d","colorbar":{"outlinewidth":0,"ticks":""}}],"scatter":[{"fillpattern":{"fillmode":"overlay","size":10,"solidity":0.2},"type":"scatter"}],"parcoords":[{"type":"parcoords","line":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterpolargl":[{"type":"scatterpolargl","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"bar":[{"error_x":{"color":"#2a3f5f"},"error_y":{"color":"#2a3f5f"},"marker":{"line":{"color":"#E5ECF6","width":0.5},"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"bar"}],"scattergeo":[{"type":"scattergeo","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterpolar":[{"type":"scatterpolar","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"histogram":[{"marker":{"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"histogram"}],"scattergl":[{"type":"scattergl","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatter3d":[{"type":"scatter3d","line":{"colorbar":{"outlinewidth":0,"ticks":""}},"marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scattermapbox":[{"type":"scattermapbox","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterternary":[{"type":"scatterternary","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scattercarpet":[{"type":"scattercarpet","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"carpet":[{"aaxis":{"endlinecolor":"#2a3f5f","gridcolor":"white","linecolor":"white","minorgridcolor":"white","startlinecolor":"#2a3f5f"},"baxis":{"endlinecolor":"#2a3f5f","gridcolor":"white","linecolor":"white","minorgridcolor":"white","startlinecolor":"#2a3f5f"},"type":"carpet"}],"table":[{"cells":{"fill":{"color":"#EBF0F8"},"line":{"color":"white"}},"header":{"fill":{"color":"#C8D4E3"},"line":{"color":"white"}},"type":"table"}],"barpolar":[{"marker":{"line":{"color":"#E5ECF6","width":0.5},"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"barpolar"}],"pie":[{"automargin":true,"type":"pie"}]},"layout":{"autotypenumbers":"strict","colorway":["#636efa","#EF553B","#00cc96","#ab63fa","#FFA15A","#19d3f3","#FF6692","#B6E880","#FF97FF","#FECB52"],"font":{"color":"#2a3f5f"},"hovermode":"closest","hoverlabel":{"align":"left"},"paper_bgcolor":"white","plot_bgcolor":"#E5ECF6","polar":{"bgcolor":"#E5ECF6","angularaxis":{"gridcolor":"white","linecolor":"white","ticks":""},"radialaxis":{"gridcolor":"white","linecolor":"white","ticks":""}},"ternary":{"bgcolor":"#E5ECF6","aaxis":{"gridcolor":"white","linecolor":"white","ticks":""},"baxis":{"gridcolor":"white","linecolor":"white","ticks":""},"caxis":{"gridcolor":"white","linecolor":"white","ticks":""}},"coloraxis":{"colorbar":{"outlinewidth":0,"ticks":""}},"colorscale":{"sequential":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]],"sequentialminus":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]],"diverging":[[0,"#8e0152"],[0.1,"#c51b7d"],[0.2,"#de77ae"],[0.3,"#f1b6da"],[0.4,"#fde0ef"],[0.5,"#f7f7f7"],[0.6,"#e6f5d0"],[0.7,"#b8e186"],[0.8,"#7fbc41"],[0.9,"#4d9221"],[1,"#276419"]]},"xaxis":{"gridcolor":"white","linecolor":"white","ticks":"","title":{"standoff":15},"zerolinecolor":"white","automargin":true,"zerolinewidth":2},"yaxis":{"gridcolor":"white","linecolor":"white","ticks":"","title":{"standoff":15},"zerolinecolor":"white","automargin":true,"zerolinewidth":2},"scene":{"xaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2},"yaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2},"zaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2}},"shapedefaults":{"line":{"color":"#2a3f5f"}},"annotationdefaults":{"arrowcolor":"#2a3f5f","arrowhead":0,"arrowwidth":1},"geo":{"bgcolor":"white","landcolor":"#E5ECF6","subunitcolor":"white","showland":true,"showlakes":true,"lakecolor":"white"},"title":{"x":0.05},"mapbox":{"style":"light"}}}},                        {"responsive": true}                    ).then(function(){
                            Plotly.addFrames('ca44f2f7-46f7-4844-bc1a-8dff23340d6d', [{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"1"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"2"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,1,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"3"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,1,1,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"4"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,1,2,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"5"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,1,2,1,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"6"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,1,2,2,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"7"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,2,2,2,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"8"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,2,2,2,1,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"9"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,2,2,2,2,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"10"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"11"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,1,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"12"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,1,1,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"13"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,1,2,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"14"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,1,2,1],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"15"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,1,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"16"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"17"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[2,2,2,2,2,2,2,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"18"}]);
                        }).then(function(){
                            
var gd = document.getElementById('ca44f2f7-46f7-4844-bc1a-8dff23340d6d');
var x = new MutationObserver(function (mutations, observer) {{
        var display = window.getComputedStyle(gd).display;
        if (!display || display === 'none') {{
            console.log([gd, 'removed!']);
            Plotly.purge(gd);
            observer.disconnect();
        }}
}});

// Listen for the removal of the full notebook cells
var notebookContainer = gd.closest('#notebook-container');
if (notebookContainer) {{
    x.observe(notebookContainer, {childList: true});
}}

// Listen for the clearing of the current output cell
var outputEl = gd.closest('.output');
if (outputEl) {{
    x.observe(outputEl, {childList: true});
}}

                        })                };                });            </script>        </div>

    (None, 5)

## Install

``` sh
pip install recursion_visualizer
```

or

``` sh
conda install -c conda-forge recursion_visualizer
```

## How to Use

Simply add the
[`RecursionVisualizer`](https://ez2rok.github.io/recursion-visualizer/recurse.html#recursionvisualizer)
decorator to your recursive function and get a beautiful, interactive
animation!

Toggle the DP button to visualize which function calls are evaluated
with and without dynamic programming (DP).

## Examples

### Fibonacci

Visualize computing the n-th [fibonacci
number](https://en.wikipedia.org/wiki/Fibonacci_number) like this:

``` python
@RecursionVisualizer()
def fibonacci(n):
  if n <= 2: 
    return 1
  return fibonacci(n-1) + fibonacci(n-2)
```

``` python
fibonacci(5)
```

        <script type="text/javascript">
        window.PlotlyConfig = {MathJaxConfig: 'local'};
        if (window.MathJax && window.MathJax.Hub && window.MathJax.Hub.Config) {window.MathJax.Hub.Config({SVG: {font: "STIX-Web"}});}
        if (typeof require !== 'undefined') {
        require.undef("plotly");
        requirejs.config({
            paths: {
                'plotly': ['https://cdn.plot.ly/plotly-2.14.0.min']
            }
        });
        require(['plotly'], function(Plotly) {
            window._Plotly = Plotly;
        });
        }
        </script>
        
<div>                            <div id="9715cf0b-90c7-4501-815d-aa95523bb187" class="plotly-graph-div" style="height:525px; width:100%;"></div>            <script type="text/javascript">                require(["plotly"], function(Plotly) {                    window.PLOTLYENV=window.PLOTLYENV || {};                                    if (document.getElementById("9715cf0b-90c7-4501-815d-aa95523bb187")) {                    Plotly.newPlot(                        "9715cf0b-90c7-4501-815d-aa95523bb187",                        [{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[0,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],                        {"annotations":[{"showarrow":false,"text":"Made with <a href='https://github.com/ez2rok/recursion-visualizer'>Recursion Visualizer</a>","x":0.005,"xref":"paper","y":-0.002,"yref":"paper"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":158.0,"xref":"x","y":203.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":104.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":50.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":86.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":140.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":194.0,"xref":"x","y":203.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":212.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"","x":248.0,"xref":"x","y":131.0,"yref":"y"}],"margin":{"b":0,"l":5,"r":5,"t":5},"sliders":[{"active":0,"currentvalue":{"font":{"size":20},"prefix":"Time:","visible":true,"xanchor":"right"},"len":0.9,"pad":{"b":5,"t":5},"steps":[{"args":[[0],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"0","method":"animate"},{"args":[[1],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"1","method":"animate"},{"args":[[2],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"2","method":"animate"},{"args":[[3],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"3","method":"animate"},{"args":[[4],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"4","method":"animate"},{"args":[[5],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"5","method":"animate"},{"args":[[6],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"6","method":"animate"},{"args":[[7],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"7","method":"animate"},{"args":[[8],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"8","method":"animate"},{"args":[[9],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"9","method":"animate"},{"args":[[10],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"10","method":"animate"},{"args":[[11],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"11","method":"animate"},{"args":[[12],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"12","method":"animate"},{"args":[[13],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"13","method":"animate"},{"args":[[14],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"14","method":"animate"},{"args":[[15],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"15","method":"animate"},{"args":[[16],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"16","method":"animate"},{"args":[[17],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"17","method":"animate"},{"args":[[18],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"18","method":"animate"}],"transition":{"duration":300,"easing":"cubic-in-out"},"x":0.1,"xanchor":"left","y":0,"yanchor":"top"}],"title":{"text":"Recursive Tree: fibonacci(5)","x":0.02,"xanchor":"left","y":0.95,"yanchor":"top"},"updatemenus":[{"buttons":[{"args":[null,{"frame":{"duration":500,"redraw":false},"fromcurrent":true,"transition":{"duration":300,"easing":"quadratic-in-out"}}],"label":"Play","method":"animate"},{"args":[[null],{"frame":{"duration":0,"redraw":false},"mode":"immediate","transition":{"duration":0}}],"label":"Pause","method":"animate"}],"direction":"up","pad":{"r":20,"t":15},"showactive":true,"type":"buttons","x":0.1,"xanchor":"right","y":0,"yanchor":"top"}],"xaxis":{"showgrid":false,"showline":false,"showticklabels":false,"zeroline":false},"yaxis":{"showgrid":false,"showline":false,"showticklabels":false,"zeroline":false},"template":{"data":{"histogram2dcontour":[{"type":"histogram2dcontour","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"choropleth":[{"type":"choropleth","colorbar":{"outlinewidth":0,"ticks":""}}],"histogram2d":[{"type":"histogram2d","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"heatmap":[{"type":"heatmap","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"heatmapgl":[{"type":"heatmapgl","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"contourcarpet":[{"type":"contourcarpet","colorbar":{"outlinewidth":0,"ticks":""}}],"contour":[{"type":"contour","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"surface":[{"type":"surface","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"mesh3d":[{"type":"mesh3d","colorbar":{"outlinewidth":0,"ticks":""}}],"scatter":[{"fillpattern":{"fillmode":"overlay","size":10,"solidity":0.2},"type":"scatter"}],"parcoords":[{"type":"parcoords","line":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterpolargl":[{"type":"scatterpolargl","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"bar":[{"error_x":{"color":"#2a3f5f"},"error_y":{"color":"#2a3f5f"},"marker":{"line":{"color":"#E5ECF6","width":0.5},"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"bar"}],"scattergeo":[{"type":"scattergeo","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterpolar":[{"type":"scatterpolar","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"histogram":[{"marker":{"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"histogram"}],"scattergl":[{"type":"scattergl","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatter3d":[{"type":"scatter3d","line":{"colorbar":{"outlinewidth":0,"ticks":""}},"marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scattermapbox":[{"type":"scattermapbox","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterternary":[{"type":"scatterternary","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scattercarpet":[{"type":"scattercarpet","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"carpet":[{"aaxis":{"endlinecolor":"#2a3f5f","gridcolor":"white","linecolor":"white","minorgridcolor":"white","startlinecolor":"#2a3f5f"},"baxis":{"endlinecolor":"#2a3f5f","gridcolor":"white","linecolor":"white","minorgridcolor":"white","startlinecolor":"#2a3f5f"},"type":"carpet"}],"table":[{"cells":{"fill":{"color":"#EBF0F8"},"line":{"color":"white"}},"header":{"fill":{"color":"#C8D4E3"},"line":{"color":"white"}},"type":"table"}],"barpolar":[{"marker":{"line":{"color":"#E5ECF6","width":0.5},"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"barpolar"}],"pie":[{"automargin":true,"type":"pie"}]},"layout":{"autotypenumbers":"strict","colorway":["#636efa","#EF553B","#00cc96","#ab63fa","#FFA15A","#19d3f3","#FF6692","#B6E880","#FF97FF","#FECB52"],"font":{"color":"#2a3f5f"},"hovermode":"closest","hoverlabel":{"align":"left"},"paper_bgcolor":"white","plot_bgcolor":"#E5ECF6","polar":{"bgcolor":"#E5ECF6","angularaxis":{"gridcolor":"white","linecolor":"white","ticks":""},"radialaxis":{"gridcolor":"white","linecolor":"white","ticks":""}},"ternary":{"bgcolor":"#E5ECF6","aaxis":{"gridcolor":"white","linecolor":"white","ticks":""},"baxis":{"gridcolor":"white","linecolor":"white","ticks":""},"caxis":{"gridcolor":"white","linecolor":"white","ticks":""}},"coloraxis":{"colorbar":{"outlinewidth":0,"ticks":""}},"colorscale":{"sequential":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]],"sequentialminus":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]],"diverging":[[0,"#8e0152"],[0.1,"#c51b7d"],[0.2,"#de77ae"],[0.3,"#f1b6da"],[0.4,"#fde0ef"],[0.5,"#f7f7f7"],[0.6,"#e6f5d0"],[0.7,"#b8e186"],[0.8,"#7fbc41"],[0.9,"#4d9221"],[1,"#276419"]]},"xaxis":{"gridcolor":"white","linecolor":"white","ticks":"","title":{"standoff":15},"zerolinecolor":"white","automargin":true,"zerolinewidth":2},"yaxis":{"gridcolor":"white","linecolor":"white","ticks":"","title":{"standoff":15},"zerolinecolor":"white","automargin":true,"zerolinewidth":2},"scene":{"xaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2},"yaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2},"zaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2}},"shapedefaults":{"line":{"color":"#2a3f5f"}},"annotationdefaults":{"arrowcolor":"#2a3f5f","arrowhead":0,"arrowwidth":1},"geo":{"bgcolor":"white","landcolor":"#E5ECF6","subunitcolor":"white","showland":true,"showlakes":true,"lakecolor":"white"},"title":{"x":0.05},"mapbox":{"style":"light"}}}},                        {"responsive": true}                    ).then(function(){
                            Plotly.addFrames('9715cf0b-90c7-4501-815d-aa95523bb187', [{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"1"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"2"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,1,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"3"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,1,1,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"4"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,1,2,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"5"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,1,2,1,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"6"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,1,2,2,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"7"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,2,2,2,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"8"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,2,2,2,1,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"9"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,1,2,2,2,2,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"10"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"11"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,1,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"12"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,1,1,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"13"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,1,2,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"14"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,1,2,1],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"15"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,1,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"16"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"17"},{"data":[{"hoverinfo":"text","hovertext":["fibonacci(5)=5<br>discover: 0<br>finish: 17","fibonacci(4)=3<br>discover: 1<br>finish: 10","fibonacci(3)=2<br>discover: 2<br>finish: 7","fibonacci(2)=1<br>discover: 3<br>finish: 4","fibonacci(1)=1<br>discover: 5<br>finish: 6","fibonacci(2)=1<br>discover: 8<br>finish: 9","fibonacci(3)=2<br>discover: 11<br>finish: 16","fibonacci(2)=1<br>discover: 12<br>finish: 13","fibonacci(1)=1<br>discover: 14<br>finish: 15"],"ids":[0,1,2,3,4,5,6,7,8],"marker":{"cmid":1,"color":[2,2,2,2,2,2,2,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":17},"mode":"markers+text","showlegend":false,"text":["5","4","3","2","1","2","3","2","1"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[171.0,135.0,63.0,27.0,99.0,135.0,207.0,207.0,279.0],"y":[234.0,162.0,90.0,18.0,18.0,90.0,162.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[171.0,135.0,null,171.0,207.0,null,135.0,63.0,null,135.0,135.0,null,63.0,27.0,null,63.0,99.0,null,207.0,207.0,null,207.0,279.0,null],"y":[234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"18"}]);
                        }).then(function(){
                            
var gd = document.getElementById('9715cf0b-90c7-4501-815d-aa95523bb187');
var x = new MutationObserver(function (mutations, observer) {{
        var display = window.getComputedStyle(gd).display;
        if (!display || display === 'none') {{
            console.log([gd, 'removed!']);
            Plotly.purge(gd);
            observer.disconnect();
        }}
}});

// Listen for the removal of the full notebook cells
var notebookContainer = gd.closest('#notebook-container');
if (notebookContainer) {{
    x.observe(notebookContainer, {childList: true});
}}

// Listen for the clearing of the current output cell
var outputEl = gd.closest('.output');
if (outputEl) {{
    x.observe(outputEl, {childList: true});
}}

                        })                };                });            </script>        </div>

    (None, 5)

There are several things to note:

- Each node represents a single call to `fibonacci`
- If `fibonacci(i)` calls `fibonacci(i-1)` and `fibonacci(i-2)`, then
  the node `i` will have children `i-1` and `i-2`
- The tree is rooted at `5` because we initially called the function
  `fibonacci(5)`
- `1` and `2` are the the leaves of this tree because the base cases of
  `fibonacci` is when `i=1` or `i=2`
- The animation illustrates the order in which the computer evaluates
  all of the `fibonacci` calls
- Toggle the `DP` button to see how using dynamic programming (DP)
  changes which function calls are evaluated

### 0-1 Knapsack

Visualzie the [0-1
knapsack](https://en.wikipedia.org/wiki/Knapsack_problem#0-1_knapsack_problem)
problem like this:

``` python
@RecursionVisualizer(display_args=[0])
def knapsack(capacity, weights, values, i, edge_label=''):
  
  # create edge labels
  label_1 = 'skip W={}, V={}'.format(weights[i-1], values[i-1])
  label_2 = 'skip W={}, V={}'.format(weights[i-1], values[i-1])
  label_3 = 'take W={}, V={}'.format(weights[i-1], values[i-1])
  
  # base case
  if i == 0 or capacity == 0:
    return 0
  
  # if the weight of the current item is more than the capacity
  if weights[i-1] > capacity:
    return knapsack(capacity, weights, values, i-1, edge_label=label_1)
  
  # return the maximum of two cases: including the ith-item or not including it
  return max(knapsack(capacity, weights, values, i-1, edge_label=label_2),
             values[i-1] + knapsack(capacity-weights[i-1], weights, values, i-1, edge_label=label_3))
```

``` python
weights = [10, 20]
values = [60, 100]
capacity = 50

knapsack(capacity, weights, values, len(weights))
```

<div>                            <div id="4332b35f-68b0-4001-8be2-59be3b321b42" class="plotly-graph-div" style="height:525px; width:100%;"></div>            <script type="text/javascript">                require(["plotly"], function(Plotly) {                    window.PLOTLYENV=window.PLOTLYENV || {};                                    if (document.getElementById("4332b35f-68b0-4001-8be2-59be3b321b42")) {                    Plotly.newPlot(                        "4332b35f-68b0-4001-8be2-59be3b321b42",                        [{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],                        {"annotations":[{"showarrow":false,"text":"Made with <a href='https://github.com/ez2rok/recursion-visualizer'>Recursion Visualizer</a>","x":0.005,"xref":"paper","y":-0.002,"yref":"paper"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"skip W=20, V=100","x":122.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"skip W=10, V=60","x":68.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"take W=10, V=60","x":104.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"take W=20, V=100","x":158.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"skip W=10, V=60","x":176.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"take W=10, V=60","x":212.0,"xref":"x","y":59.0,"yref":"y"}],"margin":{"b":0,"l":5,"r":5,"t":5},"sliders":[{"active":0,"currentvalue":{"font":{"size":20},"prefix":"Time:","visible":true,"xanchor":"right"},"len":0.9,"pad":{"b":5,"t":5},"steps":[{"args":[[0],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"0","method":"animate"},{"args":[[1],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"1","method":"animate"},{"args":[[2],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"2","method":"animate"},{"args":[[3],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"3","method":"animate"},{"args":[[4],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"4","method":"animate"},{"args":[[5],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"5","method":"animate"},{"args":[[6],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"6","method":"animate"},{"args":[[7],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"7","method":"animate"},{"args":[[8],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"8","method":"animate"},{"args":[[9],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"9","method":"animate"},{"args":[[10],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"10","method":"animate"},{"args":[[11],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"11","method":"animate"},{"args":[[12],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"12","method":"animate"},{"args":[[13],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"13","method":"animate"},{"args":[[14],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"14","method":"animate"}],"transition":{"duration":300,"easing":"cubic-in-out"},"x":0.1,"xanchor":"left","y":0,"yanchor":"top"}],"title":{"text":"Recursive Tree: knapsack(50,(10, 20),(60, 100),2)","x":0.02,"xanchor":"left","y":0.95,"yanchor":"top"},"updatemenus":[{"buttons":[{"args":[null,{"frame":{"duration":500,"redraw":false},"fromcurrent":true,"transition":{"duration":300,"easing":"quadratic-in-out"}}],"label":"Play","method":"animate"},{"args":[[null],{"frame":{"duration":0,"redraw":false},"mode":"immediate","transition":{"duration":0}}],"label":"Pause","method":"animate"}],"direction":"up","pad":{"r":20,"t":15},"showactive":true,"type":"buttons","x":0.1,"xanchor":"right","y":0,"yanchor":"top"}],"xaxis":{"showgrid":false,"showline":false,"showticklabels":false,"zeroline":false},"yaxis":{"showgrid":false,"showline":false,"showticklabels":false,"zeroline":false},"template":{"data":{"histogram2dcontour":[{"type":"histogram2dcontour","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"choropleth":[{"type":"choropleth","colorbar":{"outlinewidth":0,"ticks":""}}],"histogram2d":[{"type":"histogram2d","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"heatmap":[{"type":"heatmap","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"heatmapgl":[{"type":"heatmapgl","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"contourcarpet":[{"type":"contourcarpet","colorbar":{"outlinewidth":0,"ticks":""}}],"contour":[{"type":"contour","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"surface":[{"type":"surface","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"mesh3d":[{"type":"mesh3d","colorbar":{"outlinewidth":0,"ticks":""}}],"scatter":[{"fillpattern":{"fillmode":"overlay","size":10,"solidity":0.2},"type":"scatter"}],"parcoords":[{"type":"parcoords","line":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterpolargl":[{"type":"scatterpolargl","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"bar":[{"error_x":{"color":"#2a3f5f"},"error_y":{"color":"#2a3f5f"},"marker":{"line":{"color":"#E5ECF6","width":0.5},"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"bar"}],"scattergeo":[{"type":"scattergeo","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterpolar":[{"type":"scatterpolar","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"histogram":[{"marker":{"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"histogram"}],"scattergl":[{"type":"scattergl","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatter3d":[{"type":"scatter3d","line":{"colorbar":{"outlinewidth":0,"ticks":""}},"marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scattermapbox":[{"type":"scattermapbox","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterternary":[{"type":"scatterternary","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scattercarpet":[{"type":"scattercarpet","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"carpet":[{"aaxis":{"endlinecolor":"#2a3f5f","gridcolor":"white","linecolor":"white","minorgridcolor":"white","startlinecolor":"#2a3f5f"},"baxis":{"endlinecolor":"#2a3f5f","gridcolor":"white","linecolor":"white","minorgridcolor":"white","startlinecolor":"#2a3f5f"},"type":"carpet"}],"table":[{"cells":{"fill":{"color":"#EBF0F8"},"line":{"color":"white"}},"header":{"fill":{"color":"#C8D4E3"},"line":{"color":"white"}},"type":"table"}],"barpolar":[{"marker":{"line":{"color":"#E5ECF6","width":0.5},"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"barpolar"}],"pie":[{"automargin":true,"type":"pie"}]},"layout":{"autotypenumbers":"strict","colorway":["#636efa","#EF553B","#00cc96","#ab63fa","#FFA15A","#19d3f3","#FF6692","#B6E880","#FF97FF","#FECB52"],"font":{"color":"#2a3f5f"},"hovermode":"closest","hoverlabel":{"align":"left"},"paper_bgcolor":"white","plot_bgcolor":"#E5ECF6","polar":{"bgcolor":"#E5ECF6","angularaxis":{"gridcolor":"white","linecolor":"white","ticks":""},"radialaxis":{"gridcolor":"white","linecolor":"white","ticks":""}},"ternary":{"bgcolor":"#E5ECF6","aaxis":{"gridcolor":"white","linecolor":"white","ticks":""},"baxis":{"gridcolor":"white","linecolor":"white","ticks":""},"caxis":{"gridcolor":"white","linecolor":"white","ticks":""}},"coloraxis":{"colorbar":{"outlinewidth":0,"ticks":""}},"colorscale":{"sequential":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]],"sequentialminus":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]],"diverging":[[0,"#8e0152"],[0.1,"#c51b7d"],[0.2,"#de77ae"],[0.3,"#f1b6da"],[0.4,"#fde0ef"],[0.5,"#f7f7f7"],[0.6,"#e6f5d0"],[0.7,"#b8e186"],[0.8,"#7fbc41"],[0.9,"#4d9221"],[1,"#276419"]]},"xaxis":{"gridcolor":"white","linecolor":"white","ticks":"","title":{"standoff":15},"zerolinecolor":"white","automargin":true,"zerolinewidth":2},"yaxis":{"gridcolor":"white","linecolor":"white","ticks":"","title":{"standoff":15},"zerolinecolor":"white","automargin":true,"zerolinewidth":2},"scene":{"xaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2},"yaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2},"zaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2}},"shapedefaults":{"line":{"color":"#2a3f5f"}},"annotationdefaults":{"arrowcolor":"#2a3f5f","arrowhead":0,"arrowwidth":1},"geo":{"bgcolor":"white","landcolor":"#E5ECF6","subunitcolor":"white","showland":true,"showlakes":true,"lakecolor":"white"},"title":{"x":0.05},"mapbox":{"style":"light"}}}},                        {"responsive": true}                    ).then(function(){
                            Plotly.addFrames('4332b35f-68b0-4001-8be2-59be3b321b42', [{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"1"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,1,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"2"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,1,1,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"3"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,1,2,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"4"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,1,2,1,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"5"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,1,2,2,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"6"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"7"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,1,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"8"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,1,1,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"9"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,1,2,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"10"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,1,2,1],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"11"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,1,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"12"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"13"},{"data":[{"hoverinfo":"text","hovertext":["knapsack(50)=160<br>discover: 0<br>finish: 13","knapsack(50)=60<br>discover: 1<br>finish: 6","knapsack(50)=0<br>discover: 2<br>finish: 3","knapsack(40)=0<br>discover: 4<br>finish: 5","knapsack(30)=60<br>discover: 7<br>finish: 12","knapsack(30)=0<br>discover: 8<br>finish: 9","knapsack(20)=0<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[2,2,2,2,2,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":24},"mode":"markers+text","showlegend":false,"text":["50","50","50","40","30","30","20"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"14"}]);
                        }).then(function(){
                            
var gd = document.getElementById('4332b35f-68b0-4001-8be2-59be3b321b42');
var x = new MutationObserver(function (mutations, observer) {{
        var display = window.getComputedStyle(gd).display;
        if (!display || display === 'none') {{
            console.log([gd, 'removed!']);
            Plotly.purge(gd);
            observer.disconnect();
        }}
}});

// Listen for the removal of the full notebook cells
var notebookContainer = gd.closest('#notebook-container');
if (notebookContainer) {{
    x.observe(notebookContainer, {childList: true});
}}

// Listen for the clearing of the current output cell
var outputEl = gd.closest('.output');
if (outputEl) {{
    x.observe(outputEl, {childList: true});
}}

                        })                };                });            </script>        </div>

    (None, 160)

There are several things to note:

- Each node represents a single call to the `knapsack` function
- The `display_args=[0]` parameter in `@RecursionVisualizer` means that
  even though `knapsack` takes in four arguments, we will only display
  the `0`th argument in each node
- Each node displays the the capacity, how much more weight you can add
  to your knapsack (this is the `0`th argument to `knapsack`)
- This tree has a branching factor of two because every level represents
  either taking or not taking the `i`th item

### Edit Distance

Visualize computing the [edit
distance](https://en.wikipedia.org/wiki/Levenshtein_distance) like this:

``` python
@RecursionVisualizer(display_args=[0, 1])
def edit_distance(m, n, str1, str2, edge_label=''):
    
    # edge labels
    replace_label = 's1={}, s2={}'.format(str1[:m], str2[:n])
    insert_label = 's1={}, s2={}'.format(str1[:m+1], str2[:n])
    remove_label = 's1={}, s2={}'.format(str1[:m], str2[:n+1])

    # base case
    if m == 0 or n == 0: 
        return max(n, m)

    # if the last characters are the same: compute distance for the remaining strings
    if str1[m-1] == str2[n-1]:
        return edit_distance(m-1, n-1, str1, str2, edge_label=replace_label)

    # if last characters are not the same: insert, remove, and replace the last character, and return the minimum
    return 1 + min(edit_distance(m, n-1, str1, str2, edge_label=insert_label),    # insert
                edit_distance(m-1, n, str1, str2, edge_label=remove_label),       # remove
                edit_distance(m-1, n-1, str1, str2, edge_label=replace_label)     # replace
                )
```

``` python
str1, str2 = "it", "hi"
edit_distance(len(str1), len(str2), str1, str2)
```

<div>                            <div id="d62b1e14-5991-4e51-95a7-f13551cd35b4" class="plotly-graph-div" style="height:525px; width:100%;"></div>            <script type="text/javascript">                require(["plotly"], function(Plotly) {                    window.PLOTLYENV=window.PLOTLYENV || {};                                    if (document.getElementById("d62b1e14-5991-4e51-95a7-f13551cd35b4")) {                    Plotly.newPlot(                        "d62b1e14-5991-4e51-95a7-f13551cd35b4",                        [{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[0,0,0,0,0,0,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],                        {"annotations":[{"showarrow":false,"text":"Made with <a href='https://github.com/ez2rok/recursion-visualizer'>Recursion Visualizer</a>","x":0.005,"xref":"paper","y":-0.002,"yref":"paper"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=it, s2=hi","x":194.0,"xref":"x","y":203.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=it, s2=h","x":86.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=it, s2=hi","x":122.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=it, s2=h","x":68.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=i, s2=hi","x":104.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=i, s2=h","x":140.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=it, s2=h","x":158.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=it, s2=hi","x":248.0,"xref":"x","y":203.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=i, s2=hi","x":248.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=it, s2=hi","x":302.0,"xref":"x","y":203.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=it, s2=h","x":338.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=i, s2=hi","x":374.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"s1=i, s2=h","x":410.0,"xref":"x","y":131.0,"yref":"y"}],"margin":{"b":0,"l":5,"r":5,"t":5},"sliders":[{"active":0,"currentvalue":{"font":{"size":20},"prefix":"Time:","visible":true,"xanchor":"right"},"len":0.9,"pad":{"b":5,"t":5},"steps":[{"args":[[0],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"0","method":"animate"},{"args":[[1],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"1","method":"animate"},{"args":[[2],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"2","method":"animate"},{"args":[[3],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"3","method":"animate"},{"args":[[4],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"4","method":"animate"},{"args":[[5],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"5","method":"animate"},{"args":[[6],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"6","method":"animate"},{"args":[[7],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"7","method":"animate"},{"args":[[8],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"8","method":"animate"},{"args":[[9],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"9","method":"animate"},{"args":[[10],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"10","method":"animate"},{"args":[[11],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"11","method":"animate"},{"args":[[12],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"12","method":"animate"},{"args":[[13],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"13","method":"animate"},{"args":[[14],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"14","method":"animate"},{"args":[[15],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"15","method":"animate"},{"args":[[16],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"16","method":"animate"},{"args":[[17],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"17","method":"animate"},{"args":[[18],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"18","method":"animate"},{"args":[[19],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"19","method":"animate"},{"args":[[20],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"20","method":"animate"},{"args":[[21],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"21","method":"animate"},{"args":[[22],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"22","method":"animate"},{"args":[[23],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"23","method":"animate"},{"args":[[24],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"24","method":"animate"},{"args":[[25],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"25","method":"animate"},{"args":[[26],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"26","method":"animate"},{"args":[[27],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"27","method":"animate"},{"args":[[28],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"28","method":"animate"}],"transition":{"duration":300,"easing":"cubic-in-out"},"x":0.1,"xanchor":"left","y":0,"yanchor":"top"}],"title":{"text":"Recursive Tree: edit_distance(2,2,it,hi)","x":0.02,"xanchor":"left","y":0.95,"yanchor":"top"},"updatemenus":[{"buttons":[{"args":[null,{"frame":{"duration":500,"redraw":false},"fromcurrent":true,"transition":{"duration":300,"easing":"quadratic-in-out"}}],"label":"Play","method":"animate"},{"args":[[null],{"frame":{"duration":0,"redraw":false},"mode":"immediate","transition":{"duration":0}}],"label":"Pause","method":"animate"}],"direction":"up","pad":{"r":20,"t":15},"showactive":true,"type":"buttons","x":0.1,"xanchor":"right","y":0,"yanchor":"top"}],"xaxis":{"showgrid":false,"showline":false,"showticklabels":false,"zeroline":false},"yaxis":{"showgrid":false,"showline":false,"showticklabels":false,"zeroline":false},"template":{"data":{"histogram2dcontour":[{"type":"histogram2dcontour","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"choropleth":[{"type":"choropleth","colorbar":{"outlinewidth":0,"ticks":""}}],"histogram2d":[{"type":"histogram2d","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"heatmap":[{"type":"heatmap","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"heatmapgl":[{"type":"heatmapgl","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"contourcarpet":[{"type":"contourcarpet","colorbar":{"outlinewidth":0,"ticks":""}}],"contour":[{"type":"contour","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"surface":[{"type":"surface","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"mesh3d":[{"type":"mesh3d","colorbar":{"outlinewidth":0,"ticks":""}}],"scatter":[{"fillpattern":{"fillmode":"overlay","size":10,"solidity":0.2},"type":"scatter"}],"parcoords":[{"type":"parcoords","line":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterpolargl":[{"type":"scatterpolargl","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"bar":[{"error_x":{"color":"#2a3f5f"},"error_y":{"color":"#2a3f5f"},"marker":{"line":{"color":"#E5ECF6","width":0.5},"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"bar"}],"scattergeo":[{"type":"scattergeo","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterpolar":[{"type":"scatterpolar","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"histogram":[{"marker":{"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"histogram"}],"scattergl":[{"type":"scattergl","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatter3d":[{"type":"scatter3d","line":{"colorbar":{"outlinewidth":0,"ticks":""}},"marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scattermapbox":[{"type":"scattermapbox","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterternary":[{"type":"scatterternary","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scattercarpet":[{"type":"scattercarpet","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"carpet":[{"aaxis":{"endlinecolor":"#2a3f5f","gridcolor":"white","linecolor":"white","minorgridcolor":"white","startlinecolor":"#2a3f5f"},"baxis":{"endlinecolor":"#2a3f5f","gridcolor":"white","linecolor":"white","minorgridcolor":"white","startlinecolor":"#2a3f5f"},"type":"carpet"}],"table":[{"cells":{"fill":{"color":"#EBF0F8"},"line":{"color":"white"}},"header":{"fill":{"color":"#C8D4E3"},"line":{"color":"white"}},"type":"table"}],"barpolar":[{"marker":{"line":{"color":"#E5ECF6","width":0.5},"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"barpolar"}],"pie":[{"automargin":true,"type":"pie"}]},"layout":{"autotypenumbers":"strict","colorway":["#636efa","#EF553B","#00cc96","#ab63fa","#FFA15A","#19d3f3","#FF6692","#B6E880","#FF97FF","#FECB52"],"font":{"color":"#2a3f5f"},"hovermode":"closest","hoverlabel":{"align":"left"},"paper_bgcolor":"white","plot_bgcolor":"#E5ECF6","polar":{"bgcolor":"#E5ECF6","angularaxis":{"gridcolor":"white","linecolor":"white","ticks":""},"radialaxis":{"gridcolor":"white","linecolor":"white","ticks":""}},"ternary":{"bgcolor":"#E5ECF6","aaxis":{"gridcolor":"white","linecolor":"white","ticks":""},"baxis":{"gridcolor":"white","linecolor":"white","ticks":""},"caxis":{"gridcolor":"white","linecolor":"white","ticks":""}},"coloraxis":{"colorbar":{"outlinewidth":0,"ticks":""}},"colorscale":{"sequential":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]],"sequentialminus":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]],"diverging":[[0,"#8e0152"],[0.1,"#c51b7d"],[0.2,"#de77ae"],[0.3,"#f1b6da"],[0.4,"#fde0ef"],[0.5,"#f7f7f7"],[0.6,"#e6f5d0"],[0.7,"#b8e186"],[0.8,"#7fbc41"],[0.9,"#4d9221"],[1,"#276419"]]},"xaxis":{"gridcolor":"white","linecolor":"white","ticks":"","title":{"standoff":15},"zerolinecolor":"white","automargin":true,"zerolinewidth":2},"yaxis":{"gridcolor":"white","linecolor":"white","ticks":"","title":{"standoff":15},"zerolinecolor":"white","automargin":true,"zerolinewidth":2},"scene":{"xaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2},"yaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2},"zaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2}},"shapedefaults":{"line":{"color":"#2a3f5f"}},"annotationdefaults":{"arrowcolor":"#2a3f5f","arrowhead":0,"arrowwidth":1},"geo":{"bgcolor":"white","landcolor":"#E5ECF6","subunitcolor":"white","showland":true,"showlakes":true,"lakecolor":"white"},"title":{"x":0.05},"mapbox":{"style":"light"}}}},                        {"responsive": true}                    ).then(function(){
                            Plotly.addFrames('d62b1e14-5991-4e51-95a7-f13551cd35b4', [{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,0,0,0,0,0,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"1"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,0,0,0,0,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"2"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,1,0,0,0,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"3"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,2,0,0,0,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"4"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,2,1,0,0,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"5"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,2,1,1,0,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"6"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,2,1,2,0,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"7"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,2,1,2,1,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"8"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,2,1,2,2,0,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"9"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,2,1,2,2,1,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"10"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,2,1,2,2,2,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"11"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,2,2,2,2,2,0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"12"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,2,2,2,2,2,1,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"13"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,1,2,2,2,2,2,2,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"14"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"15"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,1,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"16"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,1,1,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"17"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,1,2,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"18"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,2,2,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"19"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,2,2,1,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"20"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,2,2,1,1,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"21"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,2,2,1,2,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"22"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,2,2,1,2,1,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"23"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,2,2,1,2,2,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"24"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,2,2,1,2,2,1],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"25"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,2,2,1,2,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"26"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2,2,2,2,2,2,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"27"},{"data":[{"hoverinfo":"text","hovertext":["edit_distance(2,2)=2<br>discover: 0<br>finish: 27","edit_distance(2,1)=2<br>discover: 1<br>finish: 14","edit_distance(2,0)=2<br>discover: 2<br>finish: 3","edit_distance(1,1)=1<br>discover: 4<br>finish: 11","edit_distance(1,0)=1<br>discover: 5<br>finish: 6","edit_distance(0,1)=1<br>discover: 7<br>finish: 8","edit_distance(0,0)=0<br>discover: 9<br>finish: 10","edit_distance(1,0)=1<br>discover: 12<br>finish: 13","edit_distance(1,2)=1<br>discover: 15<br>finish: 18","edit_distance(0,1)=1<br>discover: 16<br>finish: 17","edit_distance(1,1)=1<br>discover: 19<br>finish: 26","edit_distance(1,0)=1<br>discover: 20<br>finish: 21","edit_distance(0,1)=1<br>discover: 22<br>finish: 23","edit_distance(0,0)=0<br>discover: 24<br>finish: 25"],"ids":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"marker":{"cmid":1,"color":[2,2,2,2,2,2,2,2,2,2,2,2,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["2,2","2,1","2,0","1,1","1,0","0,1","0,0","1,0","1,2","0,1","1,1","1,0","0,1","0,0"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[243.0,135.0,27.0,99.0,27.0,99.0,171.0,171.0,243.0,243.0,351.0,315.0,387.0,459.0],"y":[234.0,162.0,90.0,90.0,18.0,18.0,18.0,90.0,162.0,90.0,162.0,90.0,90.0,90.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[243.0,135.0,null,243.0,243.0,null,243.0,351.0,null,135.0,27.0,null,135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,99.0,171.0,null,243.0,243.0,null,351.0,315.0,null,351.0,387.0,null,351.0,459.0,null],"y":[234.0,162.0,null,234.0,162.0,null,234.0,162.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null,162.0,90.0,null],"type":"scatter"}],"name":"28"}]);
                        }).then(function(){
                            
var gd = document.getElementById('d62b1e14-5991-4e51-95a7-f13551cd35b4');
var x = new MutationObserver(function (mutations, observer) {{
        var display = window.getComputedStyle(gd).display;
        if (!display || display === 'none') {{
            console.log([gd, 'removed!']);
            Plotly.purge(gd);
            observer.disconnect();
        }}
}});

// Listen for the removal of the full notebook cells
var notebookContainer = gd.closest('#notebook-container');
if (notebookContainer) {{
    x.observe(notebookContainer, {childList: true});
}}

// Listen for the clearing of the current output cell
var outputEl = gd.closest('.output');
if (outputEl) {{
    x.observe(outputEl, {childList: true});
}}

                        })                };                });            </script>        </div>

    (None, 2)

### Mergesort

Visualize the [mergesort](https://en.wikipedia.org/wiki/Merge_sort)
algorithm like this:

``` python
def mergesort_wrapper(nums):

  def merge(lo, mid, hi):
    "helper function for mergesort"
    L, R = nums[lo:mid+1] + [float('inf')], nums[mid+1:hi+1] + [float('inf')]
    i, j = 0, 0
    for k in range(lo, hi+1):
      if L[i] <= R[j]:
        nums[k] = L[i]
        i += 1
      else:
        nums[k] = R[j]
        j += 1

  @RecursionVisualizer()
  def mergesort(lo, hi, edge_label=''):

    if lo < hi:
      mid = lo + (hi-lo) // 2
      mergesort(lo, mid, edge_label='nums={}'.format(nums[lo:mid+1]))
      mergesort(mid+1, hi, edge_label='nums={}'.format(nums[mid+1:hi+1]))
      merge(lo, mid, hi)
      return nums[lo:hi+1]

  mergesort(0, len(nums)-1)  
  return nums
```

``` python
nums = [3, 1, 9, 4]
mergesort_wrapper(nums)
```

<div>                            <div id="3f432842-45e8-4115-a863-82ffa202d0be" class="plotly-graph-div" style="height:525px; width:100%;"></div>            <script type="text/javascript">                require(["plotly"], function(Plotly) {                    window.PLOTLYENV=window.PLOTLYENV || {};                                    if (document.getElementById("3f432842-45e8-4115-a863-82ffa202d0be")) {                    Plotly.newPlot(                        "3f432842-45e8-4115-a863-82ffa202d0be",                        [{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[0,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],                        {"annotations":[{"showarrow":false,"text":"Made with <a href='https://github.com/ez2rok/recursion-visualizer'>Recursion Visualizer</a>","x":0.005,"xref":"paper","y":-0.002,"yref":"paper"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"nums=[3, 1]","x":122.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"nums=[3]","x":68.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"nums=[1]","x":104.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"nums=[9, 4]","x":158.0,"xref":"x","y":131.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"nums=[9]","x":176.0,"xref":"x","y":59.0,"yref":"y"},{"font":{"color":"rgb(0,0,0)","size":10},"showarrow":false,"text":"nums=[4]","x":212.0,"xref":"x","y":59.0,"yref":"y"}],"margin":{"b":0,"l":5,"r":5,"t":5},"sliders":[{"active":0,"currentvalue":{"font":{"size":20},"prefix":"Time:","visible":true,"xanchor":"right"},"len":0.9,"pad":{"b":5,"t":5},"steps":[{"args":[[0],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"0","method":"animate"},{"args":[[1],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"1","method":"animate"},{"args":[[2],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"2","method":"animate"},{"args":[[3],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"3","method":"animate"},{"args":[[4],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"4","method":"animate"},{"args":[[5],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"5","method":"animate"},{"args":[[6],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"6","method":"animate"},{"args":[[7],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"7","method":"animate"},{"args":[[8],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"8","method":"animate"},{"args":[[9],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"9","method":"animate"},{"args":[[10],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"10","method":"animate"},{"args":[[11],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"11","method":"animate"},{"args":[[12],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"12","method":"animate"},{"args":[[13],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"13","method":"animate"},{"args":[[14],{"frame":{"duration":300,"redraw":false},"mode":"immediate","transition":{"duration":300}}],"label":"14","method":"animate"}],"transition":{"duration":300,"easing":"cubic-in-out"},"x":0.1,"xanchor":"left","y":0,"yanchor":"top"}],"title":{"text":"Recursive Tree: mergesort(0,3)","x":0.02,"xanchor":"left","y":0.95,"yanchor":"top"},"updatemenus":[{"buttons":[{"args":[null,{"frame":{"duration":500,"redraw":false},"fromcurrent":true,"transition":{"duration":300,"easing":"quadratic-in-out"}}],"label":"Play","method":"animate"},{"args":[[null],{"frame":{"duration":0,"redraw":false},"mode":"immediate","transition":{"duration":0}}],"label":"Pause","method":"animate"}],"direction":"up","pad":{"r":20,"t":15},"showactive":true,"type":"buttons","x":0.1,"xanchor":"right","y":0,"yanchor":"top"}],"xaxis":{"showgrid":false,"showline":false,"showticklabels":false,"zeroline":false},"yaxis":{"showgrid":false,"showline":false,"showticklabels":false,"zeroline":false},"template":{"data":{"histogram2dcontour":[{"type":"histogram2dcontour","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"choropleth":[{"type":"choropleth","colorbar":{"outlinewidth":0,"ticks":""}}],"histogram2d":[{"type":"histogram2d","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"heatmap":[{"type":"heatmap","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"heatmapgl":[{"type":"heatmapgl","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"contourcarpet":[{"type":"contourcarpet","colorbar":{"outlinewidth":0,"ticks":""}}],"contour":[{"type":"contour","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"surface":[{"type":"surface","colorbar":{"outlinewidth":0,"ticks":""},"colorscale":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]]}],"mesh3d":[{"type":"mesh3d","colorbar":{"outlinewidth":0,"ticks":""}}],"scatter":[{"fillpattern":{"fillmode":"overlay","size":10,"solidity":0.2},"type":"scatter"}],"parcoords":[{"type":"parcoords","line":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterpolargl":[{"type":"scatterpolargl","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"bar":[{"error_x":{"color":"#2a3f5f"},"error_y":{"color":"#2a3f5f"},"marker":{"line":{"color":"#E5ECF6","width":0.5},"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"bar"}],"scattergeo":[{"type":"scattergeo","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterpolar":[{"type":"scatterpolar","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"histogram":[{"marker":{"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"histogram"}],"scattergl":[{"type":"scattergl","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatter3d":[{"type":"scatter3d","line":{"colorbar":{"outlinewidth":0,"ticks":""}},"marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scattermapbox":[{"type":"scattermapbox","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scatterternary":[{"type":"scatterternary","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"scattercarpet":[{"type":"scattercarpet","marker":{"colorbar":{"outlinewidth":0,"ticks":""}}}],"carpet":[{"aaxis":{"endlinecolor":"#2a3f5f","gridcolor":"white","linecolor":"white","minorgridcolor":"white","startlinecolor":"#2a3f5f"},"baxis":{"endlinecolor":"#2a3f5f","gridcolor":"white","linecolor":"white","minorgridcolor":"white","startlinecolor":"#2a3f5f"},"type":"carpet"}],"table":[{"cells":{"fill":{"color":"#EBF0F8"},"line":{"color":"white"}},"header":{"fill":{"color":"#C8D4E3"},"line":{"color":"white"}},"type":"table"}],"barpolar":[{"marker":{"line":{"color":"#E5ECF6","width":0.5},"pattern":{"fillmode":"overlay","size":10,"solidity":0.2}},"type":"barpolar"}],"pie":[{"automargin":true,"type":"pie"}]},"layout":{"autotypenumbers":"strict","colorway":["#636efa","#EF553B","#00cc96","#ab63fa","#FFA15A","#19d3f3","#FF6692","#B6E880","#FF97FF","#FECB52"],"font":{"color":"#2a3f5f"},"hovermode":"closest","hoverlabel":{"align":"left"},"paper_bgcolor":"white","plot_bgcolor":"#E5ECF6","polar":{"bgcolor":"#E5ECF6","angularaxis":{"gridcolor":"white","linecolor":"white","ticks":""},"radialaxis":{"gridcolor":"white","linecolor":"white","ticks":""}},"ternary":{"bgcolor":"#E5ECF6","aaxis":{"gridcolor":"white","linecolor":"white","ticks":""},"baxis":{"gridcolor":"white","linecolor":"white","ticks":""},"caxis":{"gridcolor":"white","linecolor":"white","ticks":""}},"coloraxis":{"colorbar":{"outlinewidth":0,"ticks":""}},"colorscale":{"sequential":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]],"sequentialminus":[[0.0,"#0d0887"],[0.1111111111111111,"#46039f"],[0.2222222222222222,"#7201a8"],[0.3333333333333333,"#9c179e"],[0.4444444444444444,"#bd3786"],[0.5555555555555556,"#d8576b"],[0.6666666666666666,"#ed7953"],[0.7777777777777778,"#fb9f3a"],[0.8888888888888888,"#fdca26"],[1.0,"#f0f921"]],"diverging":[[0,"#8e0152"],[0.1,"#c51b7d"],[0.2,"#de77ae"],[0.3,"#f1b6da"],[0.4,"#fde0ef"],[0.5,"#f7f7f7"],[0.6,"#e6f5d0"],[0.7,"#b8e186"],[0.8,"#7fbc41"],[0.9,"#4d9221"],[1,"#276419"]]},"xaxis":{"gridcolor":"white","linecolor":"white","ticks":"","title":{"standoff":15},"zerolinecolor":"white","automargin":true,"zerolinewidth":2},"yaxis":{"gridcolor":"white","linecolor":"white","ticks":"","title":{"standoff":15},"zerolinecolor":"white","automargin":true,"zerolinewidth":2},"scene":{"xaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2},"yaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2},"zaxis":{"backgroundcolor":"#E5ECF6","gridcolor":"white","linecolor":"white","showbackground":true,"ticks":"","zerolinecolor":"white","gridwidth":2}},"shapedefaults":{"line":{"color":"#2a3f5f"}},"annotationdefaults":{"arrowcolor":"#2a3f5f","arrowhead":0,"arrowwidth":1},"geo":{"bgcolor":"white","landcolor":"#E5ECF6","subunitcolor":"white","showland":true,"showlakes":true,"lakecolor":"white"},"title":{"x":0.05},"mapbox":{"style":"light"}}}},                        {"responsive": true}                    ).then(function(){
                            Plotly.addFrames('3f432842-45e8-4115-a863-82ffa202d0be', [{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,0,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"1"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,1,0,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"2"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,1,1,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"3"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,1,2,0,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"4"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,1,2,1,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"5"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,1,2,2,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"6"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,0,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"7"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,1,0,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"8"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,1,1,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"9"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,1,2,0],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(0,0,0)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"10"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,1,2,1],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"11"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,1,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"12"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[1,2,2,2,2,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"13"},{"data":[{"hoverinfo":"text","hovertext":["mergesort(0,3)=[1, 3, 4, 9]<br>discover: 0<br>finish: 13","mergesort(0,1)=[1, 3]<br>discover: 1<br>finish: 6","mergesort(0,0)=None<br>discover: 2<br>finish: 3","mergesort(1,1)=None<br>discover: 4<br>finish: 5","mergesort(2,3)=[4, 9]<br>discover: 7<br>finish: 12","mergesort(2,2)=None<br>discover: 8<br>finish: 9","mergesort(3,3)=None<br>discover: 10<br>finish: 11"],"ids":[0,1,2,3,4,5,6],"marker":{"cmid":1,"color":[2,2,2,2,2,2,2],"colorscale":[[0.0,"#F7FBFF"],[0.33,"#F7FBFF"],[0.33,"#6AAED6"],[0.66,"#6AAED6"],[0.66,"#0A306B"],[1.0,"#0A306B"]],"line":{"color":"rgb(50,50,50)","width":1},"size":31},"mode":"markers+text","showlegend":false,"text":["0,3","0,1","0,0","1,1","2,3","2,2","3,3"],"textfont":{"color":["rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)","rgb(255, 255, 255)"]},"x":[135.0,99.0,27.0,99.0,171.0,171.0,243.0],"y":[162.0,90.0,18.0,18.0,90.0,18.0,18.0],"type":"scatter"},{"hoverinfo":"none","line":{"color":"#888","width":1},"mode":"lines","showlegend":false,"textposition":"bottom right","x":[135.0,99.0,null,135.0,171.0,null,99.0,27.0,null,99.0,99.0,null,171.0,171.0,null,171.0,243.0,null],"y":[162.0,90.0,null,162.0,90.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null,90.0,18.0,null],"type":"scatter"}],"name":"14"}]);
                        }).then(function(){
                            
var gd = document.getElementById('3f432842-45e8-4115-a863-82ffa202d0be');
var x = new MutationObserver(function (mutations, observer) {{
        var display = window.getComputedStyle(gd).display;
        if (!display || display === 'none') {{
            console.log([gd, 'removed!']);
            Plotly.purge(gd);
            observer.disconnect();
        }}
}});

// Listen for the removal of the full notebook cells
var notebookContainer = gd.closest('#notebook-container');
if (notebookContainer) {{
    x.observe(notebookContainer, {childList: true});
}}

// Listen for the clearing of the current output cell
var outputEl = gd.closest('.output');
if (outputEl) {{
    x.observe(outputEl, {childList: true});
}}

                        })                };                });            </script>        </div>

    [1, 3, 4, 9]

## Features

For all animations:

- Each node represents a single recursive function call
- The animation illustrates the order in which the computer evaluates
  each of these function calls
- Toggle the `DP` button to see how using dynamic programming (DP)
  changes which function calls are evaluated

Extra features:

- Hovering the cursor over a node displays additional information
- The nodes have different colors:
  - A node is **unvisited** if it is white
    <svg style="background-color: #e4ecf6" height="20" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20">
    <circle fill="#F7FBFF" cx="10" cy="10" r="9"/>
    <text x="6" y="10" font-family="Verdana" font-size="10pt" dy="0.35em">3</text>
    </svg>
  - We are **visiting** a node if it is medium blue
    <svg style="background-color: #e4ecf6" height="20" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20">
    <circle fill="#6AAED6" cx="10" cy="10" r="9"/>
    <text x="6" y="10" font-family="Verdana" font-size="10pt" dy="0.35em">3</text>
    </svg>
  - A node is **visited** if it is dark blue
    <svg style="background-color: #e4ecf6" height="20" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20">
    <circle fill="#0A306B" cx="10" cy="10" r="9"/>
    <text x="6" y="10" font-family="Verdana" font-size="10pt" dy="0.35em">3</text>
    </svg>
- At any given time, the path of medium blue nodes illustrates the
  current functions in the call stack, ie the functions that are
  currently being executed
- The leaf nodes represent the base case

## Limitations

[`RecursionVisualizer`](https://ez2rok.github.io/recursion-visualizer/recurse.html#recursionvisualizer)
is intended for educational purposes *only*. It is not intended for real
world applications or commerical use.

To create an animation of a recursive function,
[`RecursionVisualizer`](https://ez2rok.github.io/recursion-visualizer/recurse.html#recursionvisualizer)
must run the brute force version of the recursive function with no
dynamic programming. This means that
[`RecursionVisualizer`](https://ez2rok.github.io/recursion-visualizer/recurse.html#recursionvisualizer)
will often have an exponential runtime. For this reason, we recommend
using
[`RecursionVisualizer`](https://ez2rok.github.io/recursion-visualizer/recurse.html#recursionvisualizer)
on inputs no larger than `n=10`. (`n` may be the length of a string/list
or the number of vertices/edges in a graph.)

## Contributions

All contributions are welcome. Simply create a pull request to begin
contributing.

Note:
[`RecursionVisualizer`](https://ez2rok.github.io/recursion-visualizer/recurse.html#recursionvisualizer)
is made with `nbdev`, a tool to create software with notebooks. For more
information on nbdev go to their [homepage](https://nbdev.fast.ai/).

## License

MIT
